  class JellyComparator implements Comparator
  {
    public final int compare( Object a, Object b )
    {
       float z1 = ((ParticleJelly)a).pos.z;
       float z2 = ((ParticleJelly)b).pos.z;
//      float z1 = ((Vector3)a).z;
//      float z2 = ((Vector3)b).z;
  
      if( z1 > z2 )  return 1;
      else return -1;
    }
  }

/*
  // Vector class used for ordering
  class Vector3Order extends Vector3
  {
    Vector3Order()
    {
      super();
      idx = 0;
    }
  
    Vector3Order( float x, float y, float z, int i )
    {
      super( x, y, z);
      idx = i;
    }
  
    Vector3Order( Vector3 v, int i )
    {
      super( v.x, v.y, v.z );
      idx = i;
    }
    
    int idx;
  }*/


class EmitterJelly
{
  Vector3 loc;
  Vector3 vel;
  Vector3 accel;

  float radius;

  Vector3 myColor;

  JellyComparator comparator;
  ArrayList particles;
//  ArrayList particlesViewSpace;
  int maxParticles;
  
  int particleCount;

  int _nebulaTexID;
  //int _particleTexID;  
  int _tailTexID;
  
  EmitterJelly( Vector3 pos, int maxPoints )
  {
    loc        = pos;
    vel        = new Vector3();
    accel      = new Vector3();

    maxParticles = maxPoints;

    radius     = 30;

    myColor    = new Vector3( 1, 1, 1 );

    comparator = new JellyComparator();
    particles  = new ArrayList();
//    particlesViewSpace  = new ArrayList();
    particleCount = 0;
    
    _nebulaTexID = -1;
    //_particleTexID = -1;
    _tailTexID = -1;
    
  }

  /*void exist( float time )
  {
    //render();
    iterateListExist( time );
    //update( time );
  }*/
  
  void update( float time )
  {
    findAccel( time );
    vel.add( accel );
    accel.mul( 0 ); 
    vel.mul( 0.75 );
  }

  void findAccel( float time )
  {
    Vector3 noi = new Vector3();
    noi.x = (noise( time*0.1, cos(time*.25)*1, time*0.2 ) - 0.5) * .2;
    noi.y = (noise( time*0.1, sin(time*.25)*1, time*0.2 ) - 0.5) * .2;
    accel.add( noi );
  }

/*   void setPosition(){
   loc.addSelf( vel );
   
   if( ALLOWFLOOR ){
   if( loc.y > floorLevel ){
   loc.y = floorLevel;
   vel.y = 0;
   }
   }
   }*/
   
   
  void draw( int texID, float time )
  {
/*    // Sort jellyfishes in eye-space and save index for render
    particlesViewSpace.clear();
    for( int i=0; i<particles.size(); i++ )
    {
      Vector3 v0 = ((ParticleJelly)particles.get(i)).pos;
      Vector3 v1 = Vector3.transform( v0, jellys.camMatrix );
      particlesViewSpace.add( new Vector3Order(v1, i) );
    }
    Collections.sort( particlesViewSpace, comparator ); */
    Collections.sort( particles, comparator ); 
    
    /*
    // Debug
    for( int io=0; io<particlesViewSpace.size(); io++ )
    {
      Vector3Order vv = (Vector3Order)particlesViewSpace.get(io);
      println( vv.idx + "= " + vv.z );
    }*/


    //for( int i=particles.size()-1; i>=0; i-- )
    for( int i=0; i<particles.size(); i++ )
    { 
      //int idx = ((Vector3Order)particlesViewSpace.get(i)).idx;
      //ParticleJelly p = ( ParticleJelly )particles.get( idx );
      ParticleJelly p = ( ParticleJelly )particles.get( i );

      if ( !p._isDead )
      {
        p._nebulaTexID = _nebulaTexID;
        p._tailTexID = _tailTexID;
        //p._particleTexID = texID;
        p.setTexture( texID );

        p.draw( time );
        p.update( time );
        //p.exist( time );
      }
      /*else 
      {
        particles.set( idx, particles.get( particles.size() - 1 ) ); 
        particles.remove( particles.size() - 1 ); 
      }*/
    }

//    particle.disable();
  }

/*
  void addParticles( int _amt )
  {
    //Vector3 v = new Vector3(random(-.52, .52), random(-.2, .2), 0);

    for( int i=0; i<_amt; i++ )
    {
      particles.add( new ParticleJelly( particleCount+1, 1, loc, vel ) );
      
      particleCount ++;
    }

    //    if( ALLOWNEBULA ){
    //      nebulae.add( new Nebula( loc, 40.0, false ) );
    //      nebulae.add( new Nebula( loc, 100.0, false ) );
    //    }
  }
*/
  void addParticle( Vector3 pos )
  {
    particles.add( new ParticleJelly( particleCount+1, 1, pos, vel ) );
    particleCount ++;
    //    if( ALLOWNEBULA ){
    //      nebulae.add( new Nebula( loc, 40.0, false ) );
    //      nebulae.add( new Nebula( loc, 100.0, false ) );
    //    }
  }
/*
  void addParticles( int _amt, Vector3 pos )
  {
    for( int i=0; i<_amt; i++ )
    {
      particles.add( new ParticleJelly( particleCount+1, 1, pos, vel ) );
      
      particleCount ++;
    }

    //    if( ALLOWNEBULA ){
    //      nebulae.add( new Nebula( loc, 40.0, false ) );
    //      nebulae.add( new Nebula( loc, 100.0, false ) );
    //    }
  }

  void addParticles( ParticleJelly _p )
  {
    // play with amt if you want to control how many particles spawn when splitting
    int amt = (int)( _p.radius * .15 );
    for( int i=0; i<amt; i++ )
    {
      particles.add( new ParticleJelly( particleCount+1, _p.gen + 1, _p.pos, _p._vel ) );

      //      particles.add( new Particle( _p.gen + 1, _p.loc[0], _p.vel ) );
      //      if( ALLOWNEBULA )
      //        nebulae.add( new Nebula( _p.loc[0], random( 5.0, 50.0 ), true ) );
      
      particleCount ++;
    }
  }*/
}
